#include "jchartest.h"

void CreateTestFile(char *szFileName, unsigned short sCode);
void isSameShortName(LPSTR szFileName);
void isSameLongName(LPSTR szFileName);

static BOOL isValidChar(const unsigned short hexCharCode);
static BOOL isExistFile(const unsigned char *szFileName);

void checkCharCode(const unsigned char hexHigh) {
	unsigned char hexLow;

	for (hexLow = 0x40 ; hexLow <= 0xfc; hexLow++) {
		unsigned short sCode = hexLow * 0x100 + hexHigh;
		if (!isValidChar(sCode))
			continue;
		CheckChar(hexLow, hexHigh, sCode);
	} /* End of for() */
}

static BOOL isValidChar(const unsigned short hexCharCode) {
	WCHAR wWCharCode;

	if (MultiByteToWideChar(932, MB_ERR_INVALID_CHARS, 
		(char *)&hexCharCode, sizeof(hexCharCode),
		&wWCharCode, sizeof(wWCharCode)) == 0) {
		return FALSE;
	}
	return TRUE;
}

void CheckChar(unsigned char hexLow, unsigned char hexHigh, unsigned short sCode) {
	unsigned char szFileName[_MAX_PATH]; 
	unsigned char szChar[3] = {hexHigh, hexLow, 0};
	int i = 0;

	while (1) {
		sprintf(szFileName, "%s\\%s%d.TXT", stOptions.szWorkDir, szChar, i);
		if (isExistFile(szFileName) == FALSE) {
			printf("%s%d.TXT\n", szChar, i);
			CreateTestFile(szFileName, sCode);
			isSameShortName(szFileName);
			isSameLongName(szFileName);
			break; /* Exit while(1); */
		}
		else
			i++;
	} /* End of while(1) */
}

static BOOL isExistFile(const unsigned char *szFileName) {
	HANDLE hFile;

	hFile = CreateFile(szFileName, GENERIC_READ, 0, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
	if (hFile == INVALID_HANDLE_VALUE) {
		DWORD dwError = GetLastError();
		if (dwError == ERROR_FILE_NOT_FOUND) {
			return FALSE;
		}
		else {
			PrintErrorMessage(__FILE__, "CreateFile", __LINE__);
			ExitProcess(1);
		}
	}
	CloseHandle(hFile);
	return TRUE;
}
