#include "jchartest.h"

#define FULLVERSION "jchartest-0.2"

static void Usage(CHAR *argv) {
	fprintf(stderr, "%s\n", FULLVERSION);
	fprintf(stderr, "Check Filenames.\n\n");
	fprintf(stderr, "%s [-HhuVv] WorkDir\n", argv);
	fprintf(stderr, "   -u    Do not check user define characters (for EUC)\n");
	fprintf(stderr, "   -V    Print Version\n");
	fprintf(stderr, "   -v    Verbose output\n");
	fprintf(stderr, "   -[Hh] Print Help\n");
}

void Getopts(int argc, CHAR* argv[]) {
	int i;

	if (argc <= 1) {
		Usage(argv[0]);
		ExitProcess(0);
	}
//#define DEBUG
#ifdef DEBUG
	else if (argc == 2) {
		stOptions.szWorkDir = ".";
		CheckChar(0x40, 0xED, 0xED40);
		exit(1);
	}
#endif

	memset(&stOptions, 0, sizeof(stOptions));

	for (i = 1; i < argc; i++) {
		if (argv[i][0] == '-') {
			int j = 1;
			while (argv[i][j] != 0) {
				switch (argv[i][j]) {
				case 'H':
				case 'h':
					Usage(argv[0]);
					ExitProcess(0);
					break;
				case 'u':
					stOptions.bNotCheckUserDefineChars = TRUE;
					break;
				case 'v':
					stOptions.bVerbose = TRUE;
					break;
				case 'V':
					printf("%s\n", argv[0], FULLVERSION);
					ExitProcess(0);
					break;
				default:
					Usage(argv[0]);
					ExitProcess(1);
					break;
				}
				j++;
			}
		}
		else if (i == (argc-1)) {
			stOptions.szWorkDir = argv[argc-1];
		}
		else {
			Usage(argv[0]);
			ExitProcess(1);
		}
	}
}
