#include <windows.h>
#include <stdio.h>
#include <io.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <errno.h>
#include <string.h>

extern int errno;
char szTestDir[MAX_PATH];

void CreateTestFiles(unsigned char hexHigh);
int CreateTestFile(char *strFileFullName, unsigned short wCode, BOOL bCheck);
char *GetFileName(char *szFileFullPathName);
unsigned short Chr(const unsigned short wCode);
unsigned short ByteSwap(const unsigned short wShort);
BOOL IsSameShortName(LPSTR strFileFullName);
BOOL IsSameLongName(LPSTR strFileFullName);
void ReadData(char *strFileName, char *data, int ndata);

int main (int argc, char *argv[]) {
	unsigned char hexHigh;
	BOOL is_euc_check = FALSE;

	strncpy(szTestDir, argv[1], 255);
	if (!strcmp(argv[2], "euc")) {
		is_euc_check = TRUE;
	}
	szTestDir[255] = (char)0;

//	strcpy(szTestDir, "C:\\TEMP\\CHAR\\");

	/* JISA񐅏Ƌ@ˑ */
	for (hexHigh = 0x81; hexHigh <= 0x9F; hexHigh++) {
		CreateTestFiles(hexHigh);
	}

	for (hexHigh = 0xE0; hexHigh <= 0xEA; hexHigh++) {
		CreateTestFiles(hexHigh);
	}

	/* NECIIBMg */
	for (hexHigh = 0xED; hexHigh <= 0xEE; hexHigh++) {
		CreateTestFiles(hexHigh);
	}

	/* Ö */
	if (!is_euc_check) {
		for (hexHigh = 0xF0; hexHigh <= 0xF9; hexHigh++) {
			CreateTestFiles(hexHigh);
		}
	}

	/* IBMg */
	for (hexHigh = 0xFA; hexHigh <= 0xFC; hexHigh++) {
		CreateTestFiles(hexHigh);
	}
}

void CreateTestFiles(unsigned char hexHigh) {
	unsigned char hexLow;
//	unsigned int hexHigh = 0x81;

	for (hexLow = 0x40 ; hexLow <= 0xfc; hexLow++) {
		union {
			unsigned short wCode;
			unsigned char ch[1];
		} unCharCode;

		unCharCode.wCode = hexHigh * 0x100 + hexLow;

		/* Chr() ̖߂l 0 ȂÃR[hWindowsŒ`ĂȂ */
		if (Chr(unCharCode.wCode)) {
			char strFileFullName[260];

			sprintf(strFileFullName, "%s%c%c.TXT", szTestDir, 
				unCharCode.ch[1], unCharCode.ch[0]);
			if (0) printf("%s (%d)\n", strFileFullName, unCharCode.wCode);

			/* t@C̑݊mF */
			if (CreateTestFile(strFileFullName, unCharCode.wCode, TRUE) < 0) {
				/* t@C݂ꍇA炩̐KsĂ */
				if (errno == EEXIST) {
					int i;
					/* ̕R[h̃fBNg쐬 */
					sprintf(strFileFullName, "%s%c%c", szTestDir, 
						unCharCode.ch[1], unCharCode.ch[0]);
					if (CreateDirectory(strFileFullName, NULL)) {
						/* fBNg쐬 */
						/* IWĩt@C쐬 */
						unsigned char buf[6], buf2[6]; 
						int nbuf = 6;
						unsigned short wCode;

						sprintf(strFileFullName, "%s%c%c.TXT", szTestDir, 
							unCharCode.ch[1], unCharCode.ch[0]);
						ReadData(strFileFullName, buf, nbuf);

						sscanf(buf, "%x", buf2);
						sprintf(strFileFullName, "%s\\%c%c\\%c%c%d.TXT", szTestDir, 
							buf2[1], buf2[0], buf2[1], buf2[0], 1);
						wCode = buf2[1] * 0x100 + buf2[0];
						if(CreateTestFile(strFileFullName, wCode, FALSE) < 0) {
							/* fBNg쐬s */
							printf("%s cannot create\n", strFileFullName);
						}
					} /* CreateDirectory */

					/* փt@C̍쐬 */
					for (i = 1; i < 10; i++) {
						sprintf(strFileFullName, "%s\\%c%c%\\%c%c%d.TXT", szTestDir, 
							unCharCode.ch[1], unCharCode.ch[0], 
							unCharCode.ch[1], unCharCode.ch[0], i);

						if (CreateTestFile(strFileFullName, unCharCode.wCode, TRUE) < 0) {
							if (errno != EEXIST) { 
								printf("unknown error %d at %c%c\n",
									errno, unCharCode.ch[1], unCharCode.ch[0]); 
								exit(1);
							}
						}
						else {
							/* IWĩt@C쐬 */
							unsigned char buf[6], buf2[6]; 
							int nbuf = 6;
							unsigned char szFileName[256];

							sprintf(szFileName, "%s%c%c.TXT", szTestDir, 
								unCharCode.ch[1], unCharCode.ch[0]);
							ReadData(szFileName, buf, nbuf);

							sscanf(buf, "%x", buf2);
							printf("%s(%X%X) is same as %s(%X%X)\n",
								GetFileName(strFileFullName), (unsigned char)unCharCode.ch[1], (unsigned char)unCharCode.ch[0], 
								GetFileName(szFileName), buf2[1], buf2[0]);
							/* t@C쐬ł烋[v𔲂 */
							break;
						}
					} /* for */

					if ( i > 9 ) {
						printf("%s cannot create!\n", strFileFullName);
						exit (1);
					}
				} /* if errno == EEXIST */
				else { 
					printf("unknown error %d at %c%c\n", errno, unCharCode.ch[1], unCharCode.ch[0]); 
					exit(1);
				} /* if errno != EEXIST */
			} /* if CreateTestFile */
		}
	}
}

int CreateTestFile(char *strFileFullName, unsigned short wCode, BOOL bCheck) {
	int fd;
	unsigned char buf[6];
	/* t@C̑݊mF */
	if ((fd = open(strFileFullName, O_CREAT | O_EXCL | O_RDWR,
		S_IREAD | S_IWRITE)) < 0) {
			return (fd);
	}

	sprintf(buf, "%x\n", wCode);
	/* t@C݂Ȃꍇ */
	write(fd, buf, strlen(buf));
	close(fd);

	if (bCheck) {
		/* ZO͂̂ƈĂx@*/
		IsSameShortName(strFileFullName);

		/* O͂̂ƈĂx */
		IsSameLongName(strFileFullName);
	}

	return(fd);
}

void ReadData(char *strFileName, char *data, int ndata) {
	FILE *file;

	memset(data, 0, ndata);
	
	if ((file  = fopen( strFileName, "r" )) == NULL ) {
		printf("%s cannot fopen, exit\n", strFileName);
	}
	fread (data, sizeof(char), 4, file);
	fclose (file);
}

/* ZOƒOĂ邩@*/
BOOL IsSameShortName(LPSTR strFileFullName) {
	char szShortName[256];
	int  nShortName = 256;
	unsigned char buf[6], buf2[6];
	unsigned char *p, *q;
	GetShortPathName(
		(LPCTSTR)strFileFullName, // file name
		szShortName, nShortName
	);
	p = GetFileName(strFileFullName);
	q = GetFileName(szShortName);
	if (strcmp(p, q)) {
		strncpy(buf2, p, 2);
		strncpy(buf, q, 2);
		printf("%s(%X%X)'s Short Name is %s(%X%X)\n",
			p, buf2[0], buf2[1], 
			q, buf[0], buf[1]);
		return (FALSE);
		}
	else {
		return (TRUE);
	}
}

/* ZOƒOĂ邩@*/
BOOL IsSameLongName(LPSTR strFileFullName) {
	unsigned char szLongName[256];
	int  nLongName = 256;
	unsigned char buf[6], buf2[6];
	unsigned char *p, *q;

	GetLongPathName(
		(LPCTSTR)strFileFullName, // file name
		szLongName, nLongName
	);

	p = GetFileName(strFileFullName);
	q = GetFileName(szLongName);
	if (strcmp(p, q)) {
		strncpy(buf2, p, 2);
		strncpy(buf, q, 2);

		printf("%s(%X%X)'s Long Name is %s(%X%X)\n",
			p, buf2[0], buf2[1], 
			q, buf[0], buf[1]);
		return (FALSE);
	}
	else {
		return (TRUE);
	}
}

char *GetFileName(char *szFileFullPathName) {
	int len = strlen(szFileFullPathName) - 1;

	for (len ; len > 0; len--) {
		if (szFileFullPathName[len] == '\\') 
			break;
	}
	return (szFileFullPathName + len + 1);
}

unsigned short ByteSwap(const unsigned short wShort) {
	unsigned short hexHi = wShort & 0xff;
	unsigned char hexLow = wShort >> 8;
	hexHi <<=8;
	return (hexHi | hexLow);
}

unsigned short Chr(const unsigned short wCharCode) {
	unsigned short wWCharCode;
	unsigned short wCheckCharCode = ByteSwap(wCharCode);

	if (MultiByteToWideChar(
		932,               // R[h y[W
		MB_ERR_INVALID_CHARS,    // LN^ ^Cv IvV
		(char *)&wCheckCharCode,            // ΉXgÕAhX
		sizeof(wCheckCharCode),    // XgO inc null!! ̃LN^
		&wWCharCode,    // Ch LN^ obt@̃AhX
		sizeof(wWCharCode)      // obt@̃TCY
	) == 0) {
		return (0);
	}
	else {
		return (wWCharCode);
	}
}
